Remove an extraneous backslash
[obnox/wireshark/wip.git] / macosx-setup.sh
1 #!/bin/sh
2 # Setup development environment on Mac OS X (tested with 10.6.8 and Xcode 3.2.6)
3 #
4 # $Id$
5 #
6 # Trying to follow "Building Wireshark on SnowLeopard"
7 # given by Michael Tuexen at
8 # http://nplab.fh-muenster.de/groups/wiki/wiki/fb7a4/Building_Wireshark_on_SnowLeopard.html 
9 #
10
11 # To set up a GTK3 environment
12 # GTK3=1
13 # To build cmake
14 # CMAKE=1
15 #
16 # Versions to download and install.
17 #
18 # The following libraries are required.
19 #
20 GETTEXT_VERSION=0.18.1.1
21 GLIB_VERSION=2.31.8
22 #
23 # pkg-config 0.26 appears to have broken the "we have our own GLib"
24 # stuff, even if you explicitly set GLIB_CFLAGS and GLIB_LIBS.
25 # Life's too short to work around the circular dependency in a script,
26 # so we use 0.25 instead.
27 #
28 PKG_CONFIG_VERSION=0.26
29 ATK_VERSION=2.2.0
30 PANGO_VERSION=1.29.5
31 PNG_VERSION=1.5.7
32 PIXMAN_VERSION=0.24.0
33 CAIRO_VERSION=1.10.2
34 GDK_PIXBUF_VERSION=2.25.0
35 if [ -z "$GTK3" ]; then
36   GTK_VERSION=2.24.8
37 else
38   GTK_VERSION=3.2.3
39 fi
40
41 #
42 # Some package need xz to unpack their current source.
43 # xz is not available on OSX (Snow Leopard).
44 #
45 XZ_VERSION=5.0.3
46
47 # In case we want to build with cmake
48 CMAKE_VERSION=2.8.7
49
50 #
51 # The following libraries are optional.
52 # Comment them out if you don't want them, but note that some of
53 # the optional libraries are required by other optional libraries.
54 #
55 LIBSMI_VERSION=0.4.8
56 #
57 # libgpg-error is required for libgcrypt.
58 #
59 LIBGPG_ERROR_VERSION=1.10
60 #
61 # libgcrypt is required for GnuTLS.
62 # XXX - the link for "Libgcrypt source code" at
63 # http://www.gnupg.org/download/#libgcrypt is for 1.5.0, and is a bzip2
64 # file, but http://directory.fsf.org/project/libgcrypt/ lists only
65 # 1.4.6.
66 #
67 LIBGCRYPT_VERSION=1.4.6
68 GNUTLS_VERSION=2.12.7
69 LUA_VERSION=5.1.4
70 PORTAUDIO_VERSION=pa_stable_v19_20111121
71 #
72 # XXX - they appear to have an unversioned gzipped tarball for the
73 # current version; should we just download that, with some other
74 # way of specifying whether to download the GeoIP API?
75 #
76 GEOIP_VERSION=1.4.8
77
78 #
79 # You need Xcode installed to get the compilers.
80 #
81 if [ ! -x /usr/bin/xcodebuild ]; then
82         echo "Please install Xcode first (should be available on DVD or from http://developer.apple.com/xcode/index.php)."
83         exit 1
84 fi
85
86 #
87 # You also need the X11 SDK; with at least some versions of OS X and
88 # Xcode, that is, I think, an optional install.  (Or it might be
89 # installed with X11, but I think *that* is an optional install on
90 # at least some versions of OS X.)
91 #
92 if [ ! -d /usr/X11/include ]; then
93         echo "Please install X11 and the X11 SDK first."
94         exit 1
95 fi
96
97 #
98 # Do we have permission to write in /usr/local?
99 #
100 # If so, assume we have permission to write in its subdirectories.
101 # (If that's not the case, this test needs to check the subdirectories
102 # as well.)
103 #
104 # If not, do "make install" with sudo.
105 #
106 if [ -w /usr/local ]
107 then
108         DO_MAKE_INSTALL="make install"
109 else
110         DO_MAKE_INSTALL="sudo make install"
111 fi
112
113 export PKG_CONFIG_PATH=/usr/local/lib/pkgconfig:/usr/X11/lib/pkgconfig
114
115 #
116 # Do all the downloads and untarring in a subdirectory, so all that
117 # stuff can be removed once we've installed the support libraries.
118 #
119 if [ ! -d macosx-support-libs ]
120 then
121         mkdir macosx-support-libs || exit 1
122 fi
123 cd macosx-support-libs
124
125 # Start with xz: It is the sole download format of glib later than 2.31.2
126 #
127 echo "Downloading, building, and installing xz:"
128 curl -O http://tukaani.org/xz/xz-$XZ_VERSION.tar.bz2 || exit 1
129 tar xf xz-$XZ_VERSION.tar.bz2 || exit 1
130 cd xz-$XZ_VERSION
131 CFLAGS="-D_FORTIFY_SOURCE=0" ./configure || exit 1
132 make -j 3 || exit 1
133 $DO_MAKE_INSTALL || exit 1
134 cd ..
135
136 if [ -n "$CMAKE" ]; then
137   echo "Downloading, building, and installing CMAKE:"
138   cmake_dir=`expr $CMAKE_VERSION : '\([0-9][0-9]*\.[0-9][0-9]*\).*'`
139   curl -O http://www.cmake.org/files/v$cmake_dir/cmake-$CMAKE_VERSION.tar.gz || exit 1
140   gzcat cmake-$CMAKE_VERSION.tar.gz | tar xf - || exit 1
141   cd cmake-$CMAKE_VERSION
142   ./bootstrap || exit 1
143   make -j 3 || exit 1
144   $DO_MAKE_INSTALL || exit 1
145   cd ..
146 fi
147
148 #
149 # Start with GNU gettext; GLib requires it, and OS X doesn't have it
150 # or a BSD-licensed replacement.
151 #
152 # At least on Lion with Xcode 4, _FORTIFY_SOURCE gets defined as 2
153 # by default, which causes, for example, stpncpy to be defined as
154 # a hairy macro that collides with the GNU gettext configure script's
155 # attempts to workaround AIX's lack of a declaration for stpncpy,
156 # with the result being a huge train wreck.  Define _FORTIFY_SOURCE
157 # as 0 in an attempt to keep the trains on separate tracks.
158 #
159 echo "Downloading, building, and installing GNU gettext:"
160 curl -O http://ftp.gnu.org/pub/gnu/gettext/gettext-$GETTEXT_VERSION.tar.gz || exit 1
161 tar xf gettext-$GETTEXT_VERSION.tar.gz || exit 1
162 cd gettext-$GETTEXT_VERSION
163 CFLAGS="-D_FORTIFY_SOURCE=0" ./configure || exit 1
164 make -j 3 || exit 1
165 $DO_MAKE_INSTALL || exit 1
166 cd ..
167
168 echo "Downloading, building, and installing GLib:"
169 glib_dir=`expr $GLIB_VERSION : '\([0-9][0-9]*\.[0-9][0-9]*\).*'`
170 curl -L -O http://ftp.gnome.org/pub/gnome/sources/glib/$glib_dir/glib-$GLIB_VERSION.tar.xz || exit 1
171 xzcat glib-$GLIB_VERSION.tar.xz | tar xf - || exit 1
172 cd glib-$GLIB_VERSION
173 #
174 # OS X ships with libffi, but doesn't provide its pkg-config file;
175 # explicitly specify LIBFFI_CFLAGS and LIBFFI_LIBS, so the configure
176 # script doesn't try to use pkg-config to get the appropriate
177 # CFLAGS and LIBS.
178 #
179 LIBFFI_CFLAGS="-I/usr/include/ffi" LIBFFI_LIBS="-L/usr/lib" ./configure || exit 1
180 #
181 # Mac OS X on 64-bit platforms provides libiconv, but in a form that
182 # confuses GLib.
183 #
184 patch -p1 < ../../macosx-support-lib-patches/glib-gconvert.patch || exit 1
185 make -j 3 || exit 1
186 # Apply patch: we depend on libffi, but pkg-config doesn't get told.
187 patch -p0 <../../macosx-support-lib-patches/glib-pkgconfig.patch || exit 1
188 $DO_MAKE_INSTALL || exit 1
189 cd ..
190
191 echo "Downloading, building, and installing pkg-config:"
192 curl -O http://pkgconfig.freedesktop.org/releases/pkg-config-$PKG_CONFIG_VERSION.tar.gz || exit 1
193 tar xf pkg-config-$PKG_CONFIG_VERSION.tar.gz || exit 1
194 cd pkg-config-$PKG_CONFIG_VERSION
195 # Avoid another pkgconfig call
196 GLIB_CFLAGS="-I/usr/local/include/glib-2.0 -I/usr/local/lib/glib-2.0/include" GLIB_LIBS="-L/usr/local/lib -lglib-2.0 -lintl" ./configure || exit 1
197 # ./configure || exit 1
198 make -j 3 || exit 1
199 $DO_MAKE_INSTALL || exit 1
200 cd ..
201
202 #
203 # Now we have reached a point where we can build everything but
204 # the GUI (Wireshark).
205 #
206
207 if [ -n "$GTK3" ]; then
208   #
209   # Cairo is part of Mac OS X 10.6 (and, I think, 10.5).
210   # However, it's an X11 library; if we build with "native" GTK+ rather
211   # than X11 GTK+, we might have to build and install Cairo.
212   # GTK+-3 requires a newer cairo build as well.
213   #
214   # Requirements for cairo first
215   #
216   echo "Downloading, building, and installing libpng:"
217   curl -O ftp://ftp.simplesystems.org/pub/libpng/png/src/libpng-$PNG_VERSION.tar.xz
218   xzcat libpng-$PNG_VERSION.tar.xz | tar xf - || exit 1
219   cd libpng-$PNG_VERSION
220   ./configure || exit 1
221   make -j 3 || exit 1
222   $DO_MAKE_INSTALL || exit 1
223   cd ..
224
225   echo "Downloading, building, and installing pixman:"
226   curl -O http://www.cairographics.org/releases/pixman-$PIXMAN_VERSION.tar.gz
227   gzcat pixman-$PIXMAN_VERSION.tar.gz | tar xf - || exit 1
228   cd pixman-$PIXMAN_VERSION
229   ./configure || exit 1
230   make -j 3 || exit 1
231   $DO_MAKE_INSTALL || exit 1
232   cd ..
233
234   #
235   # And now cairo itself.
236   #
237   echo "Downloading, building, and installing Cairo:"
238   curl -O http://cairographics.org/releases/cairo-$CAIRO_VERSION.tar.gz || exit 1
239   tar xvfz cairo-$CAIRO_VERSION.tar.gz || exit 1
240   cd cairo-$CAIRO_VERSION
241   #./configure --enable-quartz=no || exit 1
242   # Maybe follow http://cairographics.org/end_to_end_build_for_mac_os_x/
243   ./configure --enable-quartz=yes || exit 1
244   make -j 3 || exit 1
245   $DO_MAKE_INSTALL || exit 1
246   cd ..
247 fi 
248
249 echo "Downloading, building, and installing ATK:"
250 atk_dir=`expr $ATK_VERSION : '\([0-9][0-9]*\.[0-9][0-9]*\).*'`
251 curl -O http://ftp.gnome.org/pub/gnome/sources/atk/$atk_dir/atk-$ATK_VERSION.tar.bz2 || exit 1
252 bzcat atk-$ATK_VERSION.tar.bz2 | tar xf - || exit 1
253 cd atk-$ATK_VERSION
254 ./configure || exit 1
255 make -j 3 || exit 1
256 $DO_MAKE_INSTALL || exit 1
257 cd ..
258
259 echo "Downloading, building, and installing Pango:"
260 pango_dir=`expr $PANGO_VERSION : '\([0-9][0-9]*\.[0-9][0-9]*\).*'`
261 curl -L -O http://ftp.gnome.org/pub/gnome/sources/pango/$pango_dir/pango-$PANGO_VERSION.tar.bz2
262 bzcat pango-$PANGO_VERSION.tar.bz2 | tar xf - || exit 1
263 cd pango-$PANGO_VERSION
264 ./configure || exit 1
265 make -j 3 || exit 1
266 $DO_MAKE_INSTALL || exit 1
267 cd ..
268
269 echo "Downloading, building, and installing gdk-pixbuf:"
270 gdk_pixbuf_dir=`expr $GDK_PIXBUF_VERSION : '\([0-9][0-9]*\.[0-9][0-9]*\).*'`
271 curl -L -O http://ftp.gnome.org/pub/gnome/sources/gdk-pixbuf/$gdk_pixbuf_dir/gdk-pixbuf-$GDK_PIXBUF_VERSION.tar.xz || exit 1
272 xzcat gdk-pixbuf-$GDK_PIXBUF_VERSION.tar.xz | tar xf - || exit 1
273 cd gdk-pixbuf-$GDK_PIXBUF_VERSION
274 ./configure --without-libtiff --without-libjpeg || exit 1
275 make -j 3 || exit 1
276 $DO_MAKE_INSTALL || exit 1
277 cd ..
278
279 echo "Downloading, building, and installing GTK+:"
280 gtk_dir=`expr $GTK_VERSION : '\([0-9][0-9]*\.[0-9][0-9]*\).*'`
281 curl -L -O http://ftp.gnome.org/pub/gnome/sources/gtk+/$gtk_dir/gtk+-$GTK_VERSION.tar.xz
282 xzcat gtk+-$GTK_VERSION.tar.xz | tar xf - || exit 1
283 cd gtk+-$GTK_VERSION
284 ./configure || exit 1
285 make -j 3 || exit 1
286 $DO_MAKE_INSTALL || exit 1
287 cd ..
288
289 #
290 # Now we have reached a point where we can build everything including
291 # the GUI (Wireshark), but not with any optional features such as
292 # SNMP OID resolution, some forms of decryption, Lua scripting, playback
293 # of audio, or GeoIP mapping of IP addresses.
294 #
295 # We now conditionally download optional libraries to support them;
296 # the default is to download them all.
297 #
298
299 if [ ! -z $LIBSMI_VERSION ]
300 then
301         echo "Downloading, building, and installing libsmi:"
302         curl -L -O ftp://ftp.ibr.cs.tu-bs.de/pub/local/libsmi/libsmi-$LIBSMI_VERSION.tar.gz || exit 1
303         tar xf libsmi-$LIBSMI_VERSION.tar.gz || exit 1
304         cd libsmi-$LIBSMI_VERSION
305         ./configure || exit 1
306         make -j 3 || exit 1
307         $DO_MAKE_INSTALL || exit 1
308         cd ..
309 fi
310
311 if [ ! -z $LIBGPG_ERROR_VERSION ]
312 then
313         echo "Downloading, building, and installing libgpg-error:"
314         curl -L -O ftp://ftp.gnupg.org/gcrypt/libgpg-error/libgpg-error-$LIBGPG_ERROR_VERSION.tar.bz2 || exit 1
315         bzcat libgpg-error-$LIBGPG_ERROR_VERSION.tar.bz2 | tar xf - || exit 1
316         cd libgpg-error-$LIBGPG_ERROR_VERSION
317         ./configure || exit 1
318         make -j 3 || exit 1
319         $DO_MAKE_INSTALL || exit 1
320         cd ..
321 fi
322
323 if [ ! -z $LIBGCRYPT_VERSION ]
324 then
325         #
326         # libgpg-error is required for libgcrypt.
327         #
328         if [ -z $LIBGPG_ERROR_VERSION ]
329         then
330                 echo "libgcrypt requires libgpg-error, but you didn't install libgpg-error." 1>&2
331                 exit 1
332         fi
333
334         echo "Downloading, building, and installing libgcrypt:"
335         curl -L -O ftp://ftp.gnupg.org/gcrypt/libgcrypt/libgcrypt-$LIBGCRYPT_VERSION.tar.gz || exit 1
336         tar xf libgcrypt-$LIBGCRYPT_VERSION.tar.gz || exit 1
337         cd libgcrypt-$LIBGCRYPT_VERSION
338         #
339         # The assembler language code is not compatible with the OS X
340         # x86 assembler (or is it an x86-64 vs. x86-32 issue?).
341         #
342         ./configure --disable-asm || exit 1
343         make -j 3 || exit 1
344         $DO_MAKE_INSTALL || exit 1
345         cd ..
346 fi
347
348 if [ ! -z $GNUTLS_VERSION ]
349 then
350         #
351         # GnuTLS requires libgcrypt (or nettle, in newer versions).
352         #
353         if [ -z $LIBGCRYPT_VERSION ]
354         then
355                 echo "GnuTLS requires libgcrypt, but you didn't install libgcrypt" 1>&2
356                 exit 1
357         fi
358
359         echo "Downloading, building, and installing GnuTLS:"
360         curl -L -O http://ftp.gnu.org/gnu/gnutls/gnutls-$GNUTLS_VERSION.tar.bz2 || exit 1
361         bzcat gnutls-$GNUTLS_VERSION.tar.bz2 | tar xf - || exit 1
362         cd gnutls-$GNUTLS_VERSION
363         #
364         # Use libgcrypt, not nettle.
365         # XXX - is there some reason to prefer nettle?  Or does
366         # Wireshark directly use libgcrypt routines?
367         #
368         ./configure --with-libgcrypt || exit 1
369         make -j 3 || exit 1
370         #
371         # The pkgconfig file for GnuTLS says "requires zlib", but OS X,
372         # while it supplies zlib, doesn't supply a pkgconfig file for
373         # it.
374         #
375         # Patch the GnuTLS pkgconfig file not to require zlib.
376         # (If the capabilities of GnuTLS that Wireshark uses don't
377         # depend on building GnuTLS with zlib, an alternative would be
378         # to configure it not to use zlib.)
379         #
380         patch -p0 lib/gnutls.pc <../../macosx-support-lib-patches/gnutls-pkgconfig.patch || exit 1
381         $DO_MAKE_INSTALL || exit 1
382         cd ..
383 fi
384
385 if [ ! -z $LUA_VERSION ]
386 then
387         echo "Downloading, building, and installing Lua:"
388         curl -L -O http://www.lua.org/ftp/lua-$LUA_VERSION.tar.gz || exit 1
389         tar xf lua-$LUA_VERSION.tar.gz || exit 1
390         cd lua-$LUA_VERSION
391         make -j 3 macosx || exit 1
392         $DO_MAKE_INSTALL || exit 1
393         cd ..
394 fi
395
396 if [ ! -z $PORTAUDIO_VERSION ]
397 then
398         echo "Downloading, building, and installing PortAudio:"
399         curl -L -O http://www.portaudio.com/archives/$PORTAUDIO_VERSION.tgz || exit 1
400         tar xf $PORTAUDIO_VERSION.tgz || exit 1
401         cd portaudio
402         ./configure || exit 1
403         make -j 3 || exit 1
404         $DO_MAKE_INSTALL || exit 1
405         cd ..
406 fi
407
408 if [ ! -z $GEOIP_VERSION ]
409 then
410         echo "Downloading, building, and installing GeoIP API:"
411         curl -L -O http://geolite.maxmind.com/download/geoip/api/c/GeoIP-$GEOIP_VERSION.tar.gz || exit 1
412         tar xf GeoIP-$GEOIP_VERSION.tar.gz || exit 1
413         cd GeoIP-$GEOIP_VERSION
414         ./configure || exit 1
415         make -j 3 || exit 1
416         $DO_MAKE_INSTALL || exit 1
417         cd ..
418 fi
419
420 echo ""
421
422 echo "You are now prepared to build Wireshark. To do so do:"
423 echo "export PKG_CONFIG_PATH=/usr/local/lib/pkgconfig:/usr/X11/lib/pkgconfig"
424 echo ""
425 if [ -n "$CMAKE" ]; then
426   echo "mkdir build; cd build"
427   echo "cmake .."
428   echo
429   echo "or"
430   echo
431 fi
432 echo "./autogen.sh"
433 echo "mkdir build; cd build"
434 echo "../configure"
435 echo ""
436 echo "make -j 3"
437 echo "make install"
438
439 echo ""
440
441 echo "Make sure you are allowed capture access to the network devices"
442 echo "See: http://wiki.wireshark.org/CaptureSetup/CapturePrivileges"
443
444 echo ""
445
446 exit 0